package webserver.com;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	private static final boolean fullScreen = false;
	private static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "webserver.com", "main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                anywheresoftware.b4a.keywords.Common.Log("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
		activityBA = new BA(this, layout, processBA, "webserver.com", "main");
        processBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        initializeProcessGlobals();		
        initializeGlobals();
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (mostCurrent == null || mostCurrent != this)
			return;
        processBA.setActivityPaused(false);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyDown(keyCode, event);
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public static String _urloff = "";
public static String _urlon = "";
public static String _urloff2 = "";
public static String _urlon2 = "";
public static anywheresoftware.b4a.http.HttpClientWrapper _httpclient1 = null;
public static String  _activity_create(boolean _firsttime) throws Exception{
 //BA.debugLineNum = 22;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 23;BA.debugLine="Activity.LoadLayout(\"layout1\")";
mostCurrent._activity.LoadLayout("layout1",mostCurrent.activityBA);
 //BA.debugLineNum = 24;BA.debugLine="HttpClient1.Initialize(\"HttpClient1\")";
_httpclient1.Initialize("HttpClient1");
 //BA.debugLineNum = 25;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 31;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 33;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 27;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 29;BA.debugLine="End Sub";
return "";
}
public static String  _button2off_click() throws Exception{
anywheresoftware.b4a.http.HttpClientWrapper.HttpUriRequestWrapper _request = null;
 //BA.debugLineNum = 53;BA.debugLine="Sub Button2Off_Click";
 //BA.debugLineNum = 54;BA.debugLine="Dim request As HttpRequest";
_request = new anywheresoftware.b4a.http.HttpClientWrapper.HttpUriRequestWrapper();
 //BA.debugLineNum = 55;BA.debugLine="request.InitializeGet(URLoff2)";
_request.InitializeGet(_urloff2);
 //BA.debugLineNum = 56;BA.debugLine="HttpClient1.Execute(request,1)";
_httpclient1.Execute(processBA,_request,(int)(1));
 //BA.debugLineNum = 57;BA.debugLine="ToastMessageShow(\"LED Light Off\",False)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("LED Light Off",anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 58;BA.debugLine="End Sub";
return "";
}
public static String  _button2on_click() throws Exception{
anywheresoftware.b4a.http.HttpClientWrapper.HttpUriRequestWrapper _request = null;
 //BA.debugLineNum = 47;BA.debugLine="Sub Button2On_Click";
 //BA.debugLineNum = 48;BA.debugLine="Dim request As HttpRequest";
_request = new anywheresoftware.b4a.http.HttpClientWrapper.HttpUriRequestWrapper();
 //BA.debugLineNum = 49;BA.debugLine="request.InitializeGet(URLon2)";
_request.InitializeGet(_urlon2);
 //BA.debugLineNum = 50;BA.debugLine="HttpClient1.Execute(request,1)";
_httpclient1.Execute(processBA,_request,(int)(1));
 //BA.debugLineNum = 51;BA.debugLine="ToastMessageShow(\"LED Light On\",False)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("LED Light On",anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 52;BA.debugLine="End Sub";
return "";
}
public static String  _buttonoff_click() throws Exception{
anywheresoftware.b4a.http.HttpClientWrapper.HttpUriRequestWrapper _request = null;
 //BA.debugLineNum = 40;BA.debugLine="Sub ButtonOff_Click";
 //BA.debugLineNum = 41;BA.debugLine="Dim request As HttpRequest";
_request = new anywheresoftware.b4a.http.HttpClientWrapper.HttpUriRequestWrapper();
 //BA.debugLineNum = 42;BA.debugLine="request.InitializeGet(URLoff)";
_request.InitializeGet(_urloff);
 //BA.debugLineNum = 43;BA.debugLine="HttpClient1.Execute(request,1)";
_httpclient1.Execute(processBA,_request,(int)(1));
 //BA.debugLineNum = 44;BA.debugLine="ToastMessageShow(\"LED Light Off\",False)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("LED Light Off",anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 45;BA.debugLine="End Sub";
return "";
}
public static String  _buttonon_click() throws Exception{
anywheresoftware.b4a.http.HttpClientWrapper.HttpUriRequestWrapper _request = null;
 //BA.debugLineNum = 34;BA.debugLine="Sub ButtonOn_Click";
 //BA.debugLineNum = 35;BA.debugLine="Dim request As HttpRequest";
_request = new anywheresoftware.b4a.http.HttpClientWrapper.HttpUriRequestWrapper();
 //BA.debugLineNum = 36;BA.debugLine="request.InitializeGet(URLon)";
_request.InitializeGet(_urlon);
 //BA.debugLineNum = 37;BA.debugLine="HttpClient1.Execute(request,1)";
_httpclient1.Execute(processBA,_request,(int)(1));
 //BA.debugLineNum = 38;BA.debugLine="ToastMessageShow(\"LED Light On\",False)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("LED Light On",anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 39;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (processGlobalsRun == false) {
	    processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 16;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 20;BA.debugLine="End Sub";
return "";
}
public static String  _httpclient1_responseerror(anywheresoftware.b4a.http.HttpClientWrapper.HttpResponeWrapper _response,String _reason,int _statuscode,int _taskid) throws Exception{
 //BA.debugLineNum = 66;BA.debugLine="Sub HttpClient1_ResponseError (Response As HttpResponse, Reason As String, StatusCode As Int, TaskId As Int)";
 //BA.debugLineNum = 67;BA.debugLine="Log(\"Error connecting: \" & Reason & \" \" & StatusCode)";
anywheresoftware.b4a.keywords.Common.Log("Error connecting: "+_reason+" "+BA.NumberToString(_statuscode));
 //BA.debugLineNum = 68;BA.debugLine="If Response <> Null Then";
if (_response!= null) { 
 //BA.debugLineNum = 69;BA.debugLine="Log(Response.GetString(\"UTF8\"))";
anywheresoftware.b4a.keywords.Common.Log(_response.GetString("UTF8"));
 //BA.debugLineNum = 70;BA.debugLine="Response.Release";
_response.Release();
 };
 //BA.debugLineNum = 72;BA.debugLine="End Sub";
return "";
}
public static String  _httpclient1_responsesuccess(anywheresoftware.b4a.http.HttpClientWrapper.HttpResponeWrapper _response,int _taskid) throws Exception{
String _resultstring = "";
 //BA.debugLineNum = 60;BA.debugLine="Sub HttpClient1_ResponseSuccess (Response As HttpResponse, TaskId As Int)";
 //BA.debugLineNum = 61;BA.debugLine="Dim resultString As String";
_resultstring = "";
 //BA.debugLineNum = 62;BA.debugLine="resultString = Response.GetString(\"UTF8\")";
_resultstring = _response.GetString("UTF8");
 //BA.debugLineNum = 64;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 2;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 5;BA.debugLine="Dim URLoff As String";
_urloff = "";
 //BA.debugLineNum = 6;BA.debugLine="URLoff = \"http://192.168.1.15/?led1=off\"";
_urloff = "http://192.168.1.15/?led1=off";
 //BA.debugLineNum = 7;BA.debugLine="Dim URLon As String";
_urlon = "";
 //BA.debugLineNum = 8;BA.debugLine="URLon = \"http://192.168.1.15/?led1=on\"";
_urlon = "http://192.168.1.15/?led1=on";
 //BA.debugLineNum = 9;BA.debugLine="Dim URLoff2 As String";
_urloff2 = "";
 //BA.debugLineNum = 10;BA.debugLine="URLoff2 = \"http://192.168.1.15/?led2=off\"";
_urloff2 = "http://192.168.1.15/?led2=off";
 //BA.debugLineNum = 11;BA.debugLine="Dim URLon2 As String";
_urlon2 = "";
 //BA.debugLineNum = 12;BA.debugLine="URLon2 = \"http://192.168.1.15/?led2=on\"";
_urlon2 = "http://192.168.1.15/?led2=on";
 //BA.debugLineNum = 13;BA.debugLine="Dim HttpClient1 As HttpClient";
_httpclient1 = new anywheresoftware.b4a.http.HttpClientWrapper();
 //BA.debugLineNum = 14;BA.debugLine="End Sub";
return "";
}
}
